using System;   
using System.Threading;

public class MonitorEnterExitDemo
{       
	private int mCounter = 0;

	public void CriticalSection()       
	{
		Monitor.Enter(this);
		try
		{
			Console.WriteLine("Entering thread {0}.",
				Thread.CurrentThread.GetHashCode());
			for(int i = 1; i <= 5; i++)
			{
				mCounter++;
				Console.WriteLine("Thread{0}: counter={1}",
					Thread.CurrentThread.GetHashCode(), mCounter);
				Thread.Sleep(500);
			}
			Console.WriteLine("Exiting thread {0}.",
				Thread.CurrentThread.GetHashCode());
		}
		finally
		{
			Monitor.Exit(this);
		}
	}

	public static void Main()
	{
		MonitorEnterExitDemo demo = new MonitorEnterExitDemo();
		Thread thread1 = new Thread(new ThreadStart(demo.CriticalSection));
		thread1.Start();
		Thread thread2 = new Thread(new ThreadStart(demo.CriticalSection));
		thread2.Start();
	}
}
