using System;
using System.Threading;

namespace ResetEventExample
{
	class MainClass
	{
		const int THREADS_COUNT = 5;
			
		static void Main()
		{
			AutoResetEvent evnt = new AutoResetEvent(false);
			// ManualResetEvent evnt = new ManualResetEvent(false);

			for (int i=0; i<THREADS_COUNT; i++) 
			{
				OneWhoWaits oww = new OneWhoWaits(evnt, (i+1)*500);
				Thread thread = new Thread(new ThreadStart(oww.PerformSomeTask));
				thread.Start();
			}

			Thread.Sleep(100);

			for (int i=0; i<THREADS_COUNT; i++) 
			{
				Console.WriteLine("\nPress [Enter] to signal the Reset Event.");
				Console.ReadLine();
				evnt.Set();
				// Thread.Sleep(10);
				// evnt.Reset();
			}

			Console.WriteLine("\nMain thread finished.");
		}
	}

	class OneWhoWaits
	{
		WaitHandle mWaitHandle;
		int mWaitTime;

		public OneWhoWaits(WaitHandle aWaitHandle, int aWaitTime) 
		{
			mWaitHandle = aWaitHandle;
			mWaitTime = aWaitTime;
		}

		public void PerformSomeTask()
		{
			Console.WriteLine("Thread {0} started and sleeps.",
				Thread.CurrentThread.GetHashCode());
			Thread.Sleep(mWaitTime);
			Console.WriteLine("Thread {0} woke up and is now waiting.",
				Thread.CurrentThread.GetHashCode());
			mWaitHandle.WaitOne();
			Console.WriteLine("Thread {0} was signaled and exits.",
				Thread.CurrentThread.GetHashCode());
		}
	}
}