using System;
using System.Threading;

public class RegisterWaitExample
{
	static void Main() 
	{
		AutoResetEvent ev = new AutoResetEvent(false);
		object param = "some param";
		RegisteredWaitHandle r = ThreadPool.RegisterWaitForSingleObject( 
			ev,	new WaitOrTimerCallback(WaitProc), param, 1000, false );
		Console.WriteLine("Press [Enter] to signal the wait handle.");
		Console.ReadLine();

		Console.WriteLine("Main thread signals.");
		ev.Set();
		Console.WriteLine("Press [Enter] to continue.");
		Console.ReadLine();
		
		Console.WriteLine("Main thread unregisters.");
		r.Unregister(ev);
		Console.WriteLine("Press [Enter] to exit.");
		Console.ReadLine();
	}

	public static void WaitProc(object aState, bool aTimedOut) 
	{
		string cause = aTimedOut ? "TIMED OUT" : "SIGNALLED";
		Console.WriteLine("WaitProc executes; cause = {0}", cause);
	}
}
