using System;
using System.Threading;

namespace ThreadLocalStorage
{
	class TLSDemo
	{
		[STAThread]
		static void Main(string[] args)
		{
			Threads threads = new Threads();
			Thread createDataThread = new Thread(
				new ThreadStart(threads.CreateDataThread));
			createDataThread.Start();

			Thread readDataThread = new Thread(
				new ThreadStart(threads.ReadDataThread));
			readDataThread.Start();
			readDataThread.Join();
			createDataThread.Resume();
		}
	}

	class Threads 
	{
		private const string SLOT_NAME = "temp slot";
		
		public void CreateDataThread()
		{
			LocalDataStoreSlot slot = Thread.AllocateNamedDataSlot(SLOT_NAME);
			string data = "DATA";
			Thread.SetData(slot, data);
			Console.WriteLine("Thread1: writes data:({0}) into TLS, then suspends", data);
			Thread.CurrentThread.Suspend();
			object oData = Thread.GetData(slot);
			Console.WriteLine("Thread1: data after tampering: {0}", oData);
		}

		public void ReadDataThread()
		{
			LocalDataStoreSlot slot = Thread.GetNamedDataSlot(SLOT_NAME);
			Thread.SetData(slot, "TAMPERED DATA");
			Console.WriteLine("Thread2: tampers data in TLS, writes {0}", "TAMPERED DATA");
		}
	}
}
